#include "task.h"

Task *currentTask = NULL;
Task *firstTask = NULL;

void taskFillTSS(TSS *tss, long eip, long esp) {
  tss->ldtr = 0;
  tss->fs = tss->gs = 0;
  tss->ds = tss->es = SEL_P0_DATA;
  tss->ss = SEL_P0_STACK;
  tss->cs = SEL_P0_CODE;
  tss->eflags = 0x202L | 1 << 18;
  tss->esp = esp;
  tss->eip = eip;
}

long taskFindEmptySelector(void) {
  // find first empty GDT entry (remember, GDT entry 0
  // is zero, but we don't want to use it, hense the 2)
  return arrayFindNthEmptyElement(&GDT, 2);
}

void taskCreate(Task *task, TSS *tss) {
  int selectorIndex = taskFindEmptySelector();
  Task *llTask;

  task->tss = (long)tss;
  task->selector = selectorIndex * 8;
  //task->selector = selector;

  createDescriptor(&GDT, selectorIndex, task->tss, sizeof(TSS), D_TSS);

  if(firstTask == NULL) {
    firstTask = (Task *)task;
    currentTask = (Task *)task;
    return;
  }

  llTask = firstTask;
  while(llTask->next != NULL) llTask = (Task *)llTask->next;
  llTask->next = (long)task;

  return;
}
